<?php

namespace Taxus\Picea;

use Picea\Compiler\Context;
use Taxus\Taxus;

class Extension implements \Picea\Extension\Extension
{
    protected Taxus $taxus;

    public function __construct(Context $context, Taxus $taxus)
    {
        $this->register($context);

        $this->taxus = $taxus;
    }

    public function register(Context $context) : void
    {
        $context->pushFunction("taxus", [ $this, 'taxus' ]);
    }

    public function parse(/*\Picae\Compiler\Context*/ &$context, ?string $arguments, string $token) {
        return "";
    }

    public function taxus(string $name, ...$arguments) : bool
    {
        return $this->taxus->granted($name, ...$arguments);
    }

}
